case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac

echo "Extracting doc/Makefile (with variable substitutions)"
cat >Makefile <<!GROK!THIS!
#!$make
#
# $Id: Makefile.SH,v 1.28 2003/05/28 16:43:07 hurtta Exp $
#
#  Makefile for the documentation of the ELM mail system
#
#         (C) Copyright 1988-1992, USENET Community Trust
#
#
# Variables
#	Variables established by Configure
CHMOD		=	$chmod
CP		=	$cp
SED		=       $sed
SUBS           =       's"\#LIB\#"$lib"g; s"\#ETC\#"$etc"g;'
DEST		=	$bin
ECHO		=	$echo
FORMATTER	=	$roff
FORMATTER_OPTS	=	$roffopts
LIB		=	\$(ELM_ROOT)//$lib
LN		=	$ln
MAN		=	\$(ELM_ROOT)//$mansrc
MANEXT		=	$manext
CATMAN		=	\$(ELM_ROOT)//$catmansrc
CATMANEXT	=	$catmanext
RM		= 	$rm -f
TBL       	=	$tbl
MANROFF		=	$manroff
MANROFF_OPTS	=	$manroffopts
MV		=	$mv
TEST		=	$test
SUFFIX		=	$suffix
PACKED		=	$packed
PACKER		=	$packer
!GROK!THIS!


case "$d_dlopen_libs" in
define)  regman="\$(MAN)/elmlibregister\$(MANEXT)"
	 regcat="\$(CATMAN)/elmlibregister\$(CATMANEXT)\$(SUFFIX)"
	 regcatman="catman/elmregister\$(CATMANEXT)\$(SUFFIX)"
	 ;;
*)	 regman=
	 regcat=
	 regcatman=
	;;
esac
cat >>Makefile <<!GROK!THIS!
REGMAN		= $regman
REGCAT		= $regcat
REGCATMAN	= $regcatman

!GROK!THIS!
if $test "$roff" != none ; then
	cat >>Makefile <<!GROK!THIS!
# List of formatted guides   (obsolete)
FORMATTED_LIST	=	Alias.fmtd	\
			Config.fmtd 	\
			Cover.fmtd	\
			Form.fmtd	\
			Ref.fmtd	\
			Users.fmtd

!GROK!THIS!
else
	cat >>Makefile <<!GROK!THIS!
# No formatted quides       (obsolete)
FORMATTED_LIST	=	

!GROK!THIS!
fi


if $test "$make_sets_make" != "$define" ; then  

	cat >>Makefile <<!GROK!THIS!
MAKE		=	$make
!GROK!THIS!

fi

case "$install_prefix" in
	/*)
	echo "MANROOT       =  \$(ELM_ROOT)//$install_prefix/man" >> Makefile
	;;
	*)
	echo "MANROOT       =  " >> Makefile
	;;
esac

cat >>Makefile <<'!NO!SUBS!'

#	Other variables
SHELL		=	/bin/sh
REG		=	../bin/elmregister

# List of installed man pages (except for wnemail.1 - handled differently)
MAN_LIST	=	$(MAN)/answer$(MANEXT)		\
			$(MAN)/checkalias$(MANEXT)	\
			$(MAN)/elm$(MANEXT)		\
			$(MAN)/elmalias$(MANEXT)	\
			$(MAN)/fastmail$(MANEXT)	\
			$(MAN)/frm$(MANEXT)		\
			$(MAN)/listalias$(MANEXT)	\
			$(MAN)/messages$(MANEXT)	\
			$(MAN)/newalias$(MANEXT)	\
			$(MAN)/newmail$(MANEXT)	\
			$(MAN)/printmail$(MANEXT)	\
			$(MAN)/readmsg$(MANEXT)		\
			$(MAN)/elmcharset$(MANEXT)	\
			$(MAN)/elmrc-write$(MANEXT)	\
			$(MAN)/elmterminal$(MANEXT)	\
			$(MAN)/elmunidata$(MANEXT)	\
			$(MAN)/elmstringconvert$(MANEXT) \
			$(MAN)/prlong$(MANEXT)		\
			$(MAN)/elmregister$(MANEXT)     \
			$(REGMAN)

# List of installed catman pages (except for wnemail.1 - handled differently)
CATMAN_LIST	=	$(CATMAN)/answer$(CATMANEXT)$(SUFFIX)	\
			$(CATMAN)/checkalias$(CATMANEXT)$(SUFFIX)\
			$(CATMAN)/elm$(CATMANEXT)$(SUFFIX)	\
			$(CATMAN)/elmalias$(CATMANEXT)$(SUFFIX)\
			$(CATMAN)/fastmail$(CATMANEXT)$(SUFFIX)	\
			$(CATMAN)/frm$(CATMANEXT)$(SUFFIX)	\
			$(CATMAN)/listalias$(CATMANEXT)$(SUFFIX)	\
			$(CATMAN)/messages$(CATMANEXT)$(SUFFIX)	\
			$(CATMAN)/newalias$(CATMANEXT)$(SUFFIX)	\
			$(CATMAN)/newmail$(CATMANEXT)$(SUFFIX)	\
			$(CATMAN)/printmail$(CATMANEXT)$(SUFFIX)	\
			$(CATMAN)/readmsg$(CATMANEXT)$(SUFFIX) \
			$(CATMAN)/elmcharset$(CATMANEXT)$(SUFFIX) \
			$(CATMAN)/elmrc-write$(CATMANEXT)$(SUFFIX) \
			$(CATMAN)/elmterminal$(CATMANEXT)$(SUFFIX) \
			$(CATMAN)/elmunidata$(CATMANEXT)$(SUFFIX) \
			$(CATMAN)/elmstringconvert$(CATMANEXT)$(SUFFIX) \
			$(CATMAN)/prlong$(CATMANEXT)$(SUFFIX) \
			$(CATMAN)/elmregister$(CATMANEXT)$(SUFFIX) \
			$(REGCAT)

# List of formatted pages for catman
FORMATTED_PAGES_LIST =	catman/answer$(CATMANEXT)$(SUFFIX)	\
			catman/checkalias$(CATMANEXT)$(SUFFIX)\
			catman/elm$(CATMANEXT)$(SUFFIX)	\
			catman/elmalias$(CATMANEXT)$(SUFFIX)\
			catman/fastmail$(CATMANEXT)$(SUFFIX)	\
			catman/frm$(CATMANEXT)$(SUFFIX)	\
			catman/listalias$(CATMANEXT)$(SUFFIX)	\
			catman/messages$(CATMANEXT)$(SUFFIX)	\
			catman/newalias$(CATMANEXT)$(SUFFIX)	\
			catman/newmail$(CATMANEXT)$(SUFFIX)	\
			catman/printmail$(CATMANEXT)$(SUFFIX)	\
			catman/readmsg$(CATMANEXT)$(SUFFIX)     \
			catman/elmcharset$(CATMANEXT)$(SUFFIX)	\
			catman/elmrc-write$(CATMANEXT)$(SUFFIX)	\
			catman/elmterminal$(CATMANEXT)$(SUFFIX) \
			catman/elmunidata$(CATMANEXT)$(SUFFIX) \
			catman/elmstringconvert$(CATMANEXT)$(SUFFIX) \
			catman/prlong$(CATMANEXT)$(SUFFIX) \
			catman/elmregister$(CATMANEXT)$(SUFFIX)	\
			$(REGCATMAN)

# List of files installed in LIB directory
LIB_LIST	=	$(LIB)/elm-help.0	\
			$(LIB)/elm-help.1	\
			$(LIB)/elm-help.2	\
			$(LIB)/elm-help.3	\
			$(LIB)/elmrc-info


# Targets

!NO!SUBS!

cat >>Makefile <<!GROK!THIS!
all: 
	@if \$(TEST) $catmansrc != none; then \$(MAKE) formatted_pages ;  else true ; fi

install_s: \$(LIB_LIST)
	@if \$(TEST) $mansrc != none; then \$(MAKE) install_man ; else true ;  fi
	@if \$(TEST) $catmansrc != none; then \$(MAKE) install_catman ; else true ;  fi

uninstall_s:
	\$(REG) rm \$(LIB_LIST) 
	@if \$(TEST) $mansrc != none; then  \
		\$(REG) rm \$(MAN_LIST) \$(MAN)/wnewmail\$(MANEXT) \$(MAN)/nfrm\$(MANEXT) \$(MAN)/elmuninstall\$(MANEXT); \
	else \
		true ; \
	fi
	@if \$(TEST) $catmansrc != none; then \
		\$(REG) rm \$(CATMAN_LIST) \$(CATMAN)/wnewmail\$(CATMANEXT)\$(SUFFIX) \$(CATMAN)/nfrm\$(CATMANEXT)\$(SUFFIX) \$(CATMAN)/elmuninstall\$(CATMANEXT)\$(SUFFIX); \
	else \
		true ; \
	fi

!GROK!THIS!

cat >>Makefile <<'!NO!SUBS!'
#	The following are no-ops
lint:
clean:	

elm.1.subs: elm.1
	$(SED) $(SUBS) < elm.1 > elm.1.subs
answer.1.subs: answer.1
	$(SED) $(SUBS) < answer.1 > answer.1.subs
chkalias.1.subs: chkalias.1
	$(SED) $(SUBS) < chkalias.1 > chkalias.1.subs
elmalias.1.subs: elmalias.1
	$(SED) $(SUBS) < elmalias.1 > elmalias.1.subs
elmcharset.1.subs: elmcharset.1
	$(SED) $(SUBS) < elmcharset.1 > elmcharset.1.subs
elmrc-write.1.subs: elmrc-write.1
	$(SED) $(SUBS) < elmrc-write.1 > elmrc-write.1.subs
elmterminal.1.subs: elmterminal.1
	$(SED) $(SUBS) < elmterminal.1 > elmterminal.1.subs
elmunidata.1.subs: elmunidata.1
	$(SED) $(SUBS) < elmunidata.1 > elmunidata.1.subs
fastmail.1.subs: fastmail.1
	$(SED) $(SUBS) < fastmail.1 > fastmail.1.subs
frm.1.subs: frm.1
	$(SED) $(SUBS) < frm.1 > frm.1.subs
listalias.1.subs: listalias.1
	$(SED) $(SUBS) < listalias.1 > listalias.1.subs
messages.1.subs: messages.1
	$(SED) $(SUBS) < messages.1 > messages.1.subs
newalias.1.subs: newalias.1
	$(SED) $(SUBS) < newalias.1 > newalias.1.subs
printmail.1.subs: printmail.1
	$(SED) $(SUBS) < printmail.1 > printmail.1.subs
readmsg.1.subs: readmsg.1
	$(SED) $(SUBS) < readmsg.1 > readmsg.1.subs
newmail.1.subs: newmail.1
	$(SED) $(SUBS) < newmail.1 > newmail.1.subs
elmstringconvert.1.subs: elmstringconvert.1
	$(SED) $(SUBS) < elmstringconvert.1 > elmstringconvert.1.subs
prlong.1.subs: prlong.1
	$(SED) $(SUBS) < prlong.1 > prlong.1.subs
elmregister.1.subs: elmregister.1
	$(SED) $(SUBS) < elmregister.1 > elmregister.1.subs
elmlibregister.1.subs: elmlibregister.1
	$(SED) $(SUBS) < elmlibregister.1 > elmlibregister.1.subs


formatted_pages: catman $(FORMATTED_PAGES_LIST)

catman:
	mkdir catman

install_man: $(MANROOT) $(MAN) $(MAN_LIST) $(MAN)/wnewmail$(MANEXT) $(MAN)/nfrm$(MANEXT) $(MAN)/elmuninstall$(MANEXT)

$(MAN):
	$(REG) mkdir $(MAN)

install_catman: $(MANROOT) $(CATMAN) $(CATMAN_LIST) $(CATMAN)/wnewmail$(CATMANEXT)$(SUFFIX) \
	$(CATMAN)/nfrm$(CATMANEXT)$(SUFFIX) $(CATMAN)/elmuninstall$(CATMANEXT)$(SUFFIX) 

$(CATMAN):
	$(REG) mkdir $(CATMAN)

#	Dependencies and rules for installing man pages and lib files
$(MAN)/answer$(MANEXT):	answer.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/checkalias$(MANEXT):	chkalias.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/elm$(MANEXT):		elm.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/elmalias$(MANEXT):	elmalias.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/elmcharset$(MANEXT):	elmcharset.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/elmrc-write$(MANEXT):	elmrc-write.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/elmterminal$(MANEXT):	elmterminal.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/elmunidata$(MANEXT):	elmunidata.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/fastmail$(MANEXT):	fastmail.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/frm$(MANEXT):		frm.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/nfrm$(MANEXT):		$(MAN)/frm$(MANEXT)
				$(REG) link        $? $@

$(MAN)/elmuninstall$(MANEXT):		$(MAN)/elmregister$(MANEXT)
				$(REG) link        $? $@

$(MAN)/listalias$(MANEXT):	listalias.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/messages$(MANEXT):	messages.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/newalias$(MANEXT):	newalias.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/newmail$(MANEXT):	newmail.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/printmail$(MANEXT):	printmail.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/readmsg$(MANEXT):	readmsg.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/elmstringconvert$(MANEXT): elmstringconvert.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/prlong$(MANEXT): prlong.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/elmregister$(MANEXT): elmregister.1.subs
				$(REG) copy -m 444 $? $@

$(MAN)/elmlibregister$(MANEXT): elmlibregister.1.subs
				$(REG) copy -m 444 $? $@


$(MAN)/wnewmail$(MANEXT):	$(MAN)/newmail$(MANEXT)
				$(REG) link        $? $@

$(LIB)/elm-help.0:		elm-help.0
				$(REG) copy -m 444 $? $@

$(LIB)/elm-help.1:		elm-help.1
				$(REG) copy -m 444 $? $@

$(LIB)/elm-help.2:		elm-help.2
				$(REG) copy -m 444 $? $@

$(LIB)/elm-help.3:		elm-help.3
				$(REG) copy -m 444 $? $@

$(LIB)/elmrc-info:		elmrc-info
				$(REG) copy -m 444 $? $@

#	Dependencies and rules for installing catman
$(CATMAN)/answer$(CATMANEXT)$(SUFFIX):	catman/answer$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/checkalias$(CATMANEXT)$(SUFFIX): catman/checkalias$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/elm$(CATMANEXT)$(SUFFIX): catman/elm$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/elmalias$(CATMANEXT)$(SUFFIX): catman/elmalias$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/elmcharset$(CATMANEXT)$(SUFFIX): catman/elmcharset$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/elmrc-write$(CATMANEXT)$(SUFFIX): catman/elmrc-write$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/elmunidata$(CATMANEXT)$(SUFFIX): catman/elmunidata$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/elmterminal$(CATMANEXT)$(SUFFIX): catman/elmterminal$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/fastmail$(CATMANEXT)$(SUFFIX): catman/fastmail$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/frm$(CATMANEXT)$(SUFFIX): catman/frm$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/listalias$(CATMANEXT)$(SUFFIX): catman/listalias$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/messages$(CATMANEXT)$(SUFFIX): catman/messages$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/newalias$(CATMANEXT)$(SUFFIX): catman/newalias$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/newmail$(CATMANEXT)$(SUFFIX): catman/newmail$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/printmail$(CATMANEXT)$(SUFFIX): catman/printmail$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/readmsg$(CATMANEXT)$(SUFFIX): catman/readmsg$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@
				$(CHMOD) u=rw,go=r $@

$(CATMAN)/wnewmail$(CATMANEXT)$(SUFFIX): $(CATMAN)/newmail$(CATMANEXT)$(SUFFIX)
				$(REG) link        $? $@

$(CATMAN)/nfrm$(CATMANEXT)$(SUFFIX): $(CATMAN)/frm$(CATMANEXT)$(SUFFIX)
				$(REG) link        $? $@

$(CATMAN)/elmuninstall$(CATMANEXT)$(SUFFIX): $(CATMAN)/elmregister$(CATMANEXT)$(SUFFIX)
				$(REG) link        $? $@

$(CATMAN)/elmstringconvert$(CATMANEXT)$(SUFFIX): catman/elmstringconvert$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/prlong$(CATMANEXT)$(SUFFIX): catman/prlong$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/elmregister$(CATMANEXT)$(SUFFIX): catman/elmregister$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

$(CATMAN)/elmlibregister$(CATMANEXT)$(SUFFIX): catman/elmlibregister$(CATMANEXT)$(SUFFIX)
				$(REG) copy -m 444 $? $@

#	Dependencies and rules for making catman pages
catman/answer$(CATMANEXT)$(SUFFIX):		answer.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/answer$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/answer$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/checkalias$(CATMANEXT)$(SUFFIX):		chkalias.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/checkalias$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/checkalias$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/elm$(CATMANEXT)$(SUFFIX):		elm.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/elm$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/elm$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/elmalias$(CATMANEXT)$(SUFFIX):		elmalias.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/elmalias$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/elmalias$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/elmcharset$(CATMANEXT)$(SUFFIX):		elmcharset.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/elmcharset$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/elmcharset$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/elmrc-write$(CATMANEXT)$(SUFFIX): elmrc-write.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/elmrc-write$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/elmrc-write$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/elmunidata$(CATMANEXT)$(SUFFIX):		elmunidata.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/elmunidata$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/elmunidata$(CATMANEXT) ; \
	else \
		true ; \
	fi


catman/elmterminal$(CATMANEXT)$(SUFFIX):	elmterminal.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/elmterminal$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/elmterminal$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/fastmail$(CATMANEXT)$(SUFFIX):		fastmail.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/fastmail$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/fastmail$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/frm$(CATMANEXT)$(SUFFIX):		frm.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/frm$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/frm$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/listalias$(CATMANEXT)$(SUFFIX):		listalias.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/listalias$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/listalias$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/messages$(CATMANEXT)$(SUFFIX):		messages.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/messages$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/messages$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/newalias$(CATMANEXT)$(SUFFIX):		newalias.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/newalias$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/newalias$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/newmail$(CATMANEXT)$(SUFFIX):		newmail.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/newmail$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/newmail$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/printmail$(CATMANEXT)$(SUFFIX):		printmail.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/printmail$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/printmail$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/readmsg$(CATMANEXT)$(SUFFIX):		readmsg.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/readmsg$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/readmsg$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/elmstringconvert$(CATMANEXT)$(SUFFIX): elmstringconvert.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/elmstringconvert$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/elmstringconvert$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/prlong$(CATMANEXT)$(SUFFIX): prlong.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/prlong$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/prlong$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/elmregister$(CATMANEXT)$(SUFFIX): elmregister.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/elmregister$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/elmregister$(CATMANEXT) ; \
	else \
		true ; \
	fi

catman/elmlibregister$(CATMANEXT)$(SUFFIX): elmlibregister.1.subs
	$(MANROFF) $(MANROFF_OPTS) -man $? > catman/elmlibregister$(CATMANEXT)
	@if $(TEST) "$(PACKED)" = y ; then \
		$(RM) $@ ; \
		$(PACKER) catman/elmlibregister$(CATMANEXT) ; \
	else \
		true ; \
	fi

#	Dependencies and rules for formatting guides
documentation:	$(FORMATTED_LIST)

Alias.fmtd:	Alias.guide
		$(TBL) $? | $(FORMATTER) $(FORMATTER_OPTS) tmac.n - > $@

Config.fmtd:	Config.guid
		$(TBL) $? | $(FORMATTER) $(FORMATTER_OPTS) tmac.n - > $@

Cover.fmtd:	Elm.cover
		$(FORMATTER) $(FORMATTER_OPTS) tmac.n $? > $@

Form.fmtd:	Form.guide
		$(FORMATTER) $(FORMATTER_OPTS) tmac.n $? > $@

Ref.fmtd:	Ref.guide
		$(FORMATTER) $(FORMATTER_OPTS) tmac.n $? > $@

Users.fmtd:	Users.guide
		$(TBL) $? | $(FORMATTER) $(FORMATTER_OPTS) tmac.n - > $@

!NO!SUBS!

case "$install_prefix" in
	/*)
	cat >>Makefile <<'!NO!SUBS!'
$(MANROOT):
	$(REG) mkdir $(MANROOT)
!NO!SUBS!
esac

