/* $Id: defs_major.h,v 1.3 2003/03/17 17:18:32 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.3 $   $State: Exp $
 *
 *  Modified by: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 ******************************************************************************
 #  Copied from defs.h. It have following copyright:
 #
 *  The Elm Mail System
 *
 *                      Copyright (c) 1988-1992 USENET Community Trust
 *                      Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

#include <stdio.h>
#include <fcntl.h>
#include <signal.h>

#include <sys/stat.h>

#include <sys/types.h>	/* for fundamental types */
#include "../config.h"
#include "sysdefs.h"	/* system/configurable defines */

# define VERSION	"2.4ME+"		/* Version number... */

#if defined(__STDC__) || defined(_AIX)
# define ANSI_C 1
#endif

#if ANSI_C 
#define VOLATILE volatile
#define CONST    const
#define P_(x) x
#else
#define VOLATILE
#define CONST
#define P_(x) ()
#endif

#ifdef MALLOCVOID
typedef	void *	malloc_t;
#else
typedef	char *	malloc_t;
#endif

#ifdef ANSI_C
# include <stdlib.h>
#else
extern	malloc_t	calloc();
extern	int		free();
extern	malloc_t	malloc();
extern	malloc_t	realloc();
extern	void		exit();
extern char		*getenv();
#endif

#ifdef STRINGS
#  include <strings.h>
#else
#  if defined(_CONVEX_SOURCE) && defined(index)
#    undef _CONVEX_SOURCE
#    include <string.h>     /* Now there is no proto for index. */
#    define _CONVEX_SOURCE
#  else
#    include <string.h>
#  endif
#endif

#if defined(HASWAITPID) || defined(BSD_TYPE) 
#include <sys/wait.h>
#endif

#ifdef I_UNISTD
#include <unistd.h>
#else
unsigned sleep();
char *index(), *rindex(); /* names will be traslated by define in config.h */
char *strcpy(), *strcat(), *strncpy(); /* more in string.h in ANSI */
long lseek();
int fseek();
#endif

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */
