/* $Id: elm_curses.h,v 1.8 2003/02/16 10:01:26 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.8 $   $State: Exp $
 *
 *  Modified by: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 ******************************************************************************
 *  The Elm Mail System 
 *
 * 			Copyright (c) 1988-1992 USENET Community Trust
 * 			Copyright (c) 1986,1987 Dave Taylor
 ****************************************************************************/

#define OFF		0
#define ON 		1

extern int ClearScreen P_((void)), 	 
  CleartoEOLN P_((void)),
  CleartoEOS P_((void)),
  MoveCursor  P_((int, int)),
  StartBold P_((void)),        
  EndBold P_((void)), 
  StartUnderline P_((void)),   
  EndUnderline   P_((void)),
  StartHalfbright P_((void)),  
  EndHalfbright   P_((void)),
  StartInverse P_((void)),     
  EndInverse   P_((void)),
  RawState P_((void));

 /* This must be called before anything else!! */
extern int InitScreen P_((void)); 

extern void ScreenSize P_((int *lines, int *columns));
extern void Write_to_screen P_((
				CONST char *format, CONST char *msg, ...
				));
extern void PutLine0 P_((int, int, CONST char *));
extern void PutLineX P_((int, int, CONST char *, CONST char *, ...));

extern void Writechar P_((int ch));

extern int ReadCh            P_((int));
extern struct charset_state * ReadCh2 P_((int flags));
extern void SetXYLocation    P_((int x, int y));
extern void CarriageReturn   P_((void));
extern void NewLine          P_((void));
extern void Raw              P_((int state));
extern void transmit_functions P_((int newstate));
extern void GetXYLocation    P_((int *x,int *y));

extern int set_display_charset P_((charset_t set, int silent));
extern void switch_display_charset P_((int to_display));
extern charset_t * give_display_charsets P_((charset_t *storage,
					      int max));

extern int set_terminal_titles P_((char *title,char *icon));

/* May be called from signal handler 
   to_display = 0  -- suspended 
              = 1  -- as set
	      = 2  -- exiting
*/
extern void switch_title P_((int to_display));



extern struct string *curses_printable_clip P_((struct string *S,int *pos,int len,
						int *visible_len,int max_visible));


#if POLL_METHOD
int error_sleep P_((int seconds));
#endif
extern int raw_off_called P_((void));
extern void WriteRaw P_((const char *str));
extern void FlushBuffer P_((void));

