/* $Id: headers.h,v 1.18 2003/07/29 18:46:17 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.18 $   $State: Exp $
 *
 *  Modified by: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 ******************************************************************************
 *  The Elm Mail System 
 *
 * 			Copyright (c) 1988-1992 USENET Community Trust
 * 			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

/**  This is the header file for ELM mail system.  **/

#include "defs.h"
#include <setjmp.h>

#include "elmlib.h"
#include "elm_curses.h"

#include "mime.h"
/*
#include "me.h"
*/
/******** global variables accessable by all pieces of the program *******/


extern int check_size;		/* don't start mailer if no mail */

extern int header_page;         /* current header page     */
extern int inalias;		/* TRUE if in the alias menu */
extern int last_current;	/* previous current message */
extern int last_header_page;    /* last header page        */
extern int headers_per_page;	/* number of headers/page  */
extern int original_umask;	/* original umask, for restore before subshell */
extern int sendmail_verbose;    /* Allow extended debugging on sendmail */
extern int nucurr; 		/** change list or just the current pointer  **/



extern char cur_editfile[SLEN];   /* editor buffer */
extern char defaultfile[SLEN];	  /* name of default folder */

extern char item[WLEN];		/* either "message" or "alias" */
extern char items[WLEN];	/* plural: either "messages" or "aliases" */
extern char Item[WLEN];		/* CAP: either "Message" or "Alias" */
extern char Items[WLEN];	/* CAP-plural: either "Messages" or "Aliases" */
extern char Prompt[WLEN];	/* Menu Prompt: either "Command" or "Alias" */






















extern char batch_subject[SLEN];/* subject buffer for batchmail */
extern char included_file[SLEN];/* name of file to place in edit buf */




extern char version_buff[NLEN]; /* version buffer */




extern char *def_ans_yes;	/* default yes answer - single char, lc	*/
extern char *def_ans_no;	/* default no answer - single char, lc	*/
extern char *nls_deleted;	/* [deleted] */
extern char *nls_form;		/* Form */
extern char *nls_message;	/* Message */
extern char *nls_to;		/* To */
extern char *nls_from;		/* From */
extern char *nls_page;		/* Page */
extern char *change_word;	/* change */
extern char *save_word;		/* save */
extern char *copy_word;		/* copy */
extern char *cap_save_word;	/* Save */
extern char *cap_copy_word;	/* Copy */
extern char *saved_word;	/* saved */
extern char *copied_word;	/* copied */

extern char backspace,		/* the current backspace char  */

	    kill_line,		/* the current kill_line char  */
  	    word_erase,		/* the current word-erase char */
  	    interrupt_char,	/* the current interrupt char */
  	    reprint_char,	/* the current reprint-line char */
  	    eof_char;		/* the current end-of-file char */

extern int  has_highlighting;	/* highlighting available? */

/** the following two are for arbitrary weedout lists.. **/








extern int  write_elmrc;        /* flag: write elmrc in starting      */











extern int  mail_only;		/* flag: send mail then leave?        */
extern int  check_only;		/* flag: check aliases and leave?     */
extern int  batch_only;		/* flag: send without prompting?      */
































extern int elm_LINES;		/** lines per screen    **/
extern int elm_COLUMNS;		/** columns per line    **/
#ifdef SIGWINCH
VOLATILE extern int resize_screen;	/** SIGWINCH occured?   **/
#endif
VOLATILE extern int redraw_screen;	/** Elm suspended?   **/

extern long size_of_pathfd;	/** size of pathfile, 0 if none **/


extern FILE *pathfd;		/* path alias file          */
extern FILE *domainfd;		/* domains file 	    */


extern struct alias_rec **aliases; /* for the alias menu */
extern int    max_aliases;	/* number of aliases allocated */



extern int system_data;		/* fileno of system data file */
extern int user_data;		/* fileno of user data file   */








#ifdef USE_PGP

extern int pgp_status;

extern int pgp_keeppassfor; /* how long to keep it before expiring */



#endif

extern int me_retcode;
extern char *mime_types[];

