/* $Id: melib.h,v 1.38 2003/08/04 14:58:56 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.38 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 *****************************************************************************/

#ifdef USE_PGP

/* pgp_decode.c */

extern char pgp_passphrase[PGP_NUM][STRING];
extern int pgp_expires;

extern enum pgp_version have_pgp        P_((enum pgp_version v));
extern enum pgp_version decode_pgp_version P_((char * c));
extern int pgp_void_passphrase          P_((void));
extern int pgp_goodPassphrase           P_((enum pgp_version v));
extern int pgp_decrypt_init		P_((FILE **fpin, FILE **fpout, 
					    int opt, enum pgp_version v,
					    struct run_state *rs));
extern void pgp_decode  		P_((mime_t *,
					    in_state_t *s_in, 
					    out_state_t *s_out,
					    charset_t defcharset,
					    struct header_rec *mss));

extern int pgp_selector P_((mime_t *p));

extern void pgp_SG_decoder P_((mime_t *body, mime_t *sign,
			       in_state_t   *state_in,
			       out_state_t  *state_out,
			       char *micalg, 
			       charset_t defcharset,
			       struct header_rec *mss));
extern void pgp_EC_decoder P_((mime_t *init, mime_t *data,
			       in_state_t   *state_in,
			       out_state_t  *state_out,
			       charset_t     defcharset,
			       struct header_rec *mss));

#endif

/* parse_util.c */

extern char * parse_dequote P_((CONST char * quoted));
typedef void decoder_hack_func P_((char *ptr, int len));
typedef decoder_hack_func *decoder_hack;
extern char * parse_decomment P_((CONST char *quoted,
				  decoder_hack decode_mime));
extern void null_decoder_hack P_((char *ptr, int len));

typedef void encoder_hack_func P_((char *buf,int size,
				    CONST char *source,int flag));
typedef encoder_hack_func *encoder_hack;
extern void null_encoder_hack P_((char *buf,int size,
				  CONST char *source,int flag));


typedef int header_filter    P_((header_list_ptr, int));
extern int NULL_header_filter    P_((header_list_ptr, int));

extern void state_write_headers P_((out_state_t      * s,
				    header_list_ptr    hdr,
				    header_filter    * filter,
				    int                flag,
				    int                demime,
				    charset_t          defcharset));

void state_write_header P_((out_state_t * s,
			   header_list_ptr next,
			   int                demime,
			   charset_t          defcharset));
			  
extern header_list_ptr state_read_headers P_((in_state_t *, int));
extern header_list_ptr file_read_headers  P_((FILE *, int));

extern long skip_envelope P_((struct header_rec *hdr, FILE *fp));

/* mime.c */

extern void mime_panic          P_((char *,int,char *, char *));
extern int check_encoding       P_((char *));

/* mime_decode.c */

extern void melib_register_decoders(void);
extern int rfc822_header_filter     P_((header_list_ptr, int));
extern void rfc822_header_converter P_((header_list_ptr, int, char *, int));
extern void base64_decode	P_((in_state_t *, out_state_t *, int, int));
extern void quoted_printable_decode  P_((in_state_t *, out_state_t *,
					 int, int));
extern void null_decode		P_((mime_t *, in_state_t *, out_state_t *,
				    charset_t, struct header_rec *));
extern void rfc1522_decode P_((char *, int));
extern void rfc1522_decode_structured   P_((int, char *, int));
extern int rfc1522_decode_encoded_atom P_((char *trg,int trg_len,
					   CONST char * src));

extern int is_rfc1522 P_((char *));

extern int set_filter	P_((mime_t *, out_state_t *, charset_t)); 
extern FILE *arrange_decoded P_((mime_t *ptr,in_state_t  *state_in,
				 out_state_t *state_out,
				 in_state_t *newstate2,
				 char **name));

extern FILE * arrange_binary P_((mime_t *ptr,
				 in_state_t  *state_in,
				 out_state_t *state_out,
				 in_state_t *newstate2,
				 char **name));


typedef void CT_decoder	        P_((mime_t *, in_state_t *, out_state_t *,
				    charset_t, struct header_rec *));
typedef CT_decoder *CT_decoder_t;
extern CT_decoder_t select_CT_decoder	P_((mime_t *));

extern int mime_notplain P_((mime_t *p));


/* mime_parse.c */

extern mime_t *mime_t_alloc             P_((void));
extern void mime_t_clear                P_((mime_t *mt));
extern void mime_t_copy                 P_((mime_t *, mime_t *));
extern void mime_t_zero                 P_((mime_t *));
extern void mime_destroy		P_((mime_t *));
extern void mime_get_disposition        P_((char *, mime_t *));
extern void mime_get_content		P_((char *, mime_t *));
extern int class_charset                P_((char *charset_value));
extern int mime_get_charset             P_((charset_t *ret, 
					    const char *buffer,
					    charset_t * display_charset,
					    charset_t default_content_charset
					    ));
extern void mime_warnings		P_((struct header_rec *));
extern mime_t *rfc822_parse		P_((FILE *fp, int len, 
					    charset_t defcharset));
extern mime_t * multipart_parse         P_((FILE *fp, int length, 
					    char *boundary, int opts,
					    charset_t defcharset,
					    int have_boundary));
extern int mime_get_boundary           P_((char *, char *, int));

extern int mime_parse_routine		P_((struct folder_info *folder,
					    struct header_rec *hdr,
					    FILE *fp));
extern mime_t *mime_read_header         P_((FILE *fp, int opts, 
					    charset_t defcharset));
extern mime_t *parse_mime_headers       P_((header_list_ptr headers,
					    long part_offset,
					    long body_offset,
					    int opts,
					    charset_t hdr_charset));

extern void parse_mime_headers1 P_((mime_t *ptr,
				    header_list_ptr headers,
				    long part_offset,
				    long body_offset,
				    int opts,
				    charset_t hdr_charset));

extern int is_text_type P_((char *primary_type, char *subtype,int enc));
extern int is_pre_mime_content_type P_((mime_t *ptr, char *content_type));
extern int mime_check_type P_((char *str));

/* mparser.c */

extern void mime_parser_free P_((struct mime_parser_data **P));
extern int  mime_parser_subparts P_((struct mime_parser_data *P));
extern struct mimeinfo * mime_parser_index P_((struct mime_parser_data *P,
					       int idx));

/* 0 == no parser, 1 == parser found */
extern int mime_parser_parse P_((struct mimeinfo *s,
				 charset_t defcharset,
				 FILE *fp));

extern void copy_parser_data P_((struct mime_parser_data **target,
				 struct mime_parser_data *source));				 


/* mailcap.c ----------------------------------------------------------- */

extern void read_mailcaps P_((void)); 

#if ANSI_C
struct mailcap_entry;
#endif

/* Return 1 if have view command and test succees ... */

extern int mailcap_is_valid_view P_((struct mailcap_entry *f,  mime_t *p));
/* Return value must be free()ed */
extern char * mailcap_view_command P_((struct mailcap_entry *f, mime_t *p));


/* Return 1 if run succees ... */
extern int run_mailcap_view P_((char *file_name,	
				FILE * file_handle,
				out_state_t *state_out, 
				struct mailcap_entry *x, mime_t *p));

/* mime_selector.c ---------------------------------------------------- */

extern void mime_selector_free P_((struct mime_selected_handler **p));

extern int mime_classify_media P_((mime_t *p));
extern int mime_classify_subparts P_((mime_t *ptr));
extern int mime_classify_best_alternative P_((mime_t *ptr,
					      mime_t **ret));

/* Returns -1 on failure otherwise same mask than mime_classify_media() */
typedef int mime_run_selector P_((mime_t *p));
typedef mime_run_selector *mime_run_selector_t;

typedef void encrypted_decoder P_((mime_t *init, mime_t *data,
				   in_state_t   *state_in,
				   out_state_t  *state_out,
				   charset_t    defcharset,
				   struct header_rec *mss));
extern void null_EC_decoder P_((mime_t *init, mime_t *data,
				in_state_t   *state_in,
				out_state_t  *state_out,
				charset_t    defcharset,
				struct header_rec *mss));
typedef encrypted_decoder * EC_decoder_t;


typedef void signed_decoder P_((mime_t *body, mime_t *sign,
				in_state_t   *state_in,
				out_state_t  *state_out,
				char *micalg, charset_t defcharset,
				struct header_rec *mss));
extern void null_SG_decoder P_((mime_t *body,
				mime_t *sign,
				in_state_t   *state_in,
				out_state_t  *state_out,
				char *micalg,
				charset_t defcharset,
				struct header_rec *mss));
typedef signed_decoder * SG_decoder_t;



#define MIME_selector_magic     0xFD04

struct mime_selected_handler {
    unsigned short              magic;             /* MIME_selector_magic */

    struct  mt_handle_pager     *handler;          /* Found internal handler */
    struct mailcap_entry        *entry;            /* Found external handler */
  
    EC_decoder_t        EC_decoder;
    SG_decoder_t        SG_decoder;
    mime_t            * selected_alternative;

    unsigned                     use_entry:1;

};

struct  mt_handle_pager {
    CT_decoder_t        func;
    mime_run_selector_t selector;
};

extern void mime_decode		P_((mime_t *ptr, in_state_t *state_in, 
				    out_state_t *state_out,
				    charset_t defcharset, 
				    struct header_rec *mss));

/* ----------- */

#define WALKHANDLER_magic       0xFD05

struct walk_handler {
    unsigned short            magic;      /* WALKHANDLER_magic */

    struct handler_type * handler_type;

    union walk_hadler_data {
	struct search_mes  * search_mes;
	
	void               * dummy;
    } u;

};

typedef void mw_init_handler   P_((struct walk_handler *hdl));
typedef void mw_free_handler   P_((struct walk_handler *hdl));
typedef void mw_action_handler P_((struct walk_handler *hdl,mime_t *ptr,
				   in_state_t *state_in, /* May be NULL */
				   FILE *F,
				   out_state_t *state_out  /* May be NULL */ 
				   ));


#define WALKTYPE_magic          0xFD06

struct handler_type {
    unsigned short            magic;      /* WALKTYPE_magic */

    mw_init_handler    *mw_init;
    mw_free_handler    *mw_free;
    mw_action_handler  *mw_action;
};


extern struct walk_handler * malloc_walk_handler P_((struct handler_type *t));
extern void free_walk_handler P_((struct walk_handler **ptr));
extern void simple_mime_walk P_((mime_t *ptr, struct walk_handler *handler,
				 in_state_t *state_in, /* May be NULL */
				 out_state_t *state_out   /* May be NULL */
				 ));

/* partial.c */

struct partial_vector {
    mime_t   * reference;
    char     * id;                   /* Unique identifier field */
    int        number;               /* 1 .. total */
    int        total;                /* -1 if not given */
};

extern void free_partial_vector P_((struct header_rec *mss));
extern struct partial_vector *reg_partial P_((struct header_rec *mss,
					      mime_t   * reference));
extern void partial_decode  		P_((mime_t *ptr, in_state_t *s_in, 
					    out_state_t *s_out,
					    charset_t defcharset,
					    struct header_rec *mss));
extern int partial_selector P_((mime_t *p));

/* --------------- */

/* mime_decode.c uses this ... */
extern void getkey P_((int send));
extern void encode P_((char *line));


/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */
