case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac

echo "Extracting melib/Makefile (with variable substitutions)"
cat >Makefile <<!GROK!THIS!
#!$make
# $Id: Makefile.SH,v 1.16 2003/08/04 14:58:57 hurtta Exp $
#  Makefile for the ELM mail program.
#
# Variables
#	Variables established by Configure
AR		=	ar
CC		=	$cc
CCFLAGS		=	$ccflags $picflag $xencf
CHMOD		=	$chmod
LINT		=	$lint
OPTIMIZE	=	$optimize
RANLIB		=	$ranlib
RM		= 	$rm -f
TOUCH		=	$touch
TAGS		=	ctags

!GROK!THIS!

cat >>Makefile <<'!NO!SUBS!'
#	Other general variables
CFLAGS		=	-I$(INCLDIR) $(CCFLAGS) $(OPTIMIZE) $(DEBUG) 
INCLDIR		=	../hdrs
LINTFLAGS	=	-I$(INCLDIR)
SHELL		=	/bin/sh

# 	Lists
LIB_SRC		= 	parse_util.c	\
			pgp_decode.c	\
			mailcap.c	\
			mime.c		\
			mime_decode.c	\
			mime_parse.c	\
			mime_selector.c \
			mparser.c	\
			mpar_rfc822.c	\
			mpar_multipart.c \
			mpar_leaf.c	 \
			mimewalk.c	 \
			partial.c

LIB_OBJ		=	parse_util.o	\
			pgp_decode.o	\
			mailcap.o	\
			mime.o		\
			mime_decode.o	\
			mime_parse.o	\
			mime_selector.o	\
			mparser.o	\
			mpar_rfc822.o	\
			mpar_multipart.o \
			mpar_leaf.o	 \
			mimewalk.o	 \
			partial.o

all:			Makefile libme.a

install_s:		Makefile libme.a

uninstall_s:		

Makefile: Makefile.SH ../config.sh
	@echo "You must run 'sh Configure -S' or 'sh Configure'"
	exit 1

libme.a:		$(LIB_OBJ)
			$(AR) r $@ $?
			$(RANLIB) $@

lint:		
		$(LINT) $(LINTFLAGS) $(LIB_SRC) > LINT.OUT

tags:
		$(TAGS) $(LIB_SRC)

clean:		
		$(RM) $(LIB_OBJ) libme.a

# Dependencies and rules
#	Dependencies of header files upon other header files they include
.PRECIOUS:		$(INCLDIR)/defs.h $(INCLDIR)/elm.h $(INCLDIR)/headers.h def_melib.h

$(INCLDIR)/defs.h:	$(INCLDIR)/../config.h $(INCLDIR)/sysdefs.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

$(INCLDIR)/elm.h:	$(INCLDIR)/elm_curses.h $(INCLDIR)/defs.h  $(INCLDIR)/melib.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

$(INCLDIR)/headers.h:	$(INCLDIR)/elm_curses.h $(INCLDIR)/defs.h \
 $(INCLDIR)/me.h $(INCLDIR)/elmlib.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

def_melib.h:		$(INCLDIR)/headers.h $(INCLDIR)/melib.h
			$(CHMOD) u+w $@
			$(TOUCH) $@


#	Dependencies of C object files
pgp_decode.o:		def_melib.h $(INCLDIR)/s_me.h  $(INCLDIR)/s_elm.h  
parse_util.o:   	def_melib.h $(INCLDIR)/s_me.h  
mailcap.o:		def_melib.h $(INCLDIR)/melib.h 
mime_parse.o:   	def_melib.h $(INCLDIR)/s_me.h  
mime_decode.o:  	def_melib.h $(INCLDIR)/s_me.h  
mime_selector.o:	def_melib.h $(INCLDIR)/s_me.h  
mime.o:			def_melib.h $(INCLDIR)/s_me.h  
mparser.o:		def_melib.h $(INCLDIR)/mpar_imp.h
mpar_rfc822.o:		def_melib.h $(INCLDIR)/mpar_imp.h $(INCLDIR)/s_me.h  
mpar_multipart.o:	def_melib.h $(INCLDIR)/mpar_imp.h $(INCLDIR)/s_me.h  
mpar_leaf.o:		def_melib.h $(INCLDIR)/mpar_imp.h
mimewalk.o:		def_melib.h $(INCLDIR)/s_me.h  
partial.o:		def_melib.h $(INCLDIR)/s_me.h  
!NO!SUBS!

