case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac


echo "Extracting shared_libs/smtp/Makefile (with variable substitutions)"
$cat >Makefile <<!GROK!THIS!
#!$make
# $Id: Makefile.SH,v 1.11 2003/03/17 11:36:21 hurtta Exp $
#
#
#  Makefile for the ELM (ME+) mail program.
#
#  Author: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
#
#
INSTLIB		= $shlib/libelmme-smtp.so$d_shared_rev
AR		=	ar
CC		=	$cc
CCFLAGS		=	$ccflags $picflag $xencf
CP		=	$cp
RM              =       $rm -f
MV              =       $mv
OPTIMIZE	=	$optimize
RANLIB		=	$ranlib
TOUCH           =       $touch
CHMOD           =       $chmod
REG             =       ../../bin/elmregister
!GROK!THIS!

A=
if $test "$soname_include_path" = "$define" ; then
	A="$shlib/"
fi

cat >>Makefile <<SUBSTITUTE
SONAME          = ${soname_opt}${A}libelmme-smtp.so$d_shared_rev
SUBSTITUTE

$cat >>Makefile <<'!NO!SUBS!'
CFLAGS		=	-I$(INCLDIR) $(CCFLAGS) $(OPTIMIZE)
INCLDIR		=	../include
OBJS            =       smtp.o

all:	Makefile libsmtp.a ../../shlib/libelmme-smtp.so
install_s: all $(INSTLIB)

uninstall_s:
	$(REG) rm $(INSTLIB)
	
clean: 
	rm -f $(OBJS) ../../shlib/libelmme-smtp.so libsmtp.a

.PRECIOUS: $(INCLDIR)/elmshared.h ../../hdrs/defs.h 

$(INCLDIR)/elmshared.h: ../../hdrs/defs.h ../../hdrs/patchlevel.h ../../hdrs/elmlib.h $(INCLDIR)/shared.h
	$(CHMOD) u+w $@
	$(TOUCH) $@

../../hdrs/defs.h: ../../config.h ../../hdrs/sysdefs.h
	$(CHMOD) u+w $@
	$(TOUCH) $@

Makefile: Makefile.SH ../../config.sh config.res
	@echo "You must run 'sh Configure -S' or 'sh Configure'"
	exit 1

../../config.sh config.res:
	@echo "You must run 'sh Configure'"
	exit 1

lint:		

tags:

clean:		

elmsmtp.h: $(INCLDIR)/elmshared.h  ../../hdrs/mailer_imp.h \
 ../../hdrs/mbx_imp.h ../../hdrs/ss_imp.h ../../hdrs/mime.h
	$(CHMOD) u+w $@
	$(TOUCH) $@

smtp.o: elmsmtp.h ../../hdrs/rc_imp.h ../../hdrs/save_opts.h ../../hdrs/s_elm.h

libsmtp.a: $(OBJS)
	$(AR) r $@ $?
	$(RANLIB) $@

../../shlib/libelmme-smtp.so: $(OBJS)
	$(CC) $(CCFLAGS) $(SONAME) -o $@ $(OBJS) 

$(INSTLIB): ../../shlib/libelmme-smtp.so
	$(REG) copy -m 444 $? $@

!NO!SUBS!
