case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac

echo "Extracting src/Makefile (with variable substitutions)"
: if mailermode is not 2755 then we dont need the chgrp
: set chgrp to a null command in this case
if test "$mailermode" = 755; then
	chgrp=":"
fi

case "$d_locale" in
define)
	localetarget='$(ETC)/elm.mimecharsets $(ETC)/elm.terminalinfo'
	;;
*)
	localetarget=
	;;
esac

cat >Makefile <<!GROK!THIS!
#!$make
# $Id: Makefile.SH,v 1.45 2003/08/04 14:58:58 hurtta Exp $
#
#  Makefile for the ELM mail program.
#
#	Copyright (c) 1988-1992 USENET Community Trust
#	Copyright (c) 1986,1987 Dave Taylor
# 
#
# Variables
#	Variables established by Configure
CC		=	$cc
CCFLAGS		=	$ccflags $picflag $xencf
CHGRP		=	$chgrp
CHMOD		=	$chmod
CP		=	$cp
DEST		=	\$(ELM_ROOT)//$bin
ECHO		=	$echo
LFLAGS		=	$ldflags $dynamic_opt $xenlf
LIB		=	\$(ELM_ROOT)//$lib
ETC		=	\$(ELM_ROOT)//$etc
LIB2		= 	$dlopen_lib $libs 
LIBS		=	$cryptlib $termlib $dbm
LINT		=	$lint
MAILGRP		=	$mailgrp
MAILERMODE	=	$mailermode
MV		=	$mv
OPTIMIZE	=	$optimize
RM		= 	$rm -f
TOUCH		=	$touch
TAGS		=	ctags

LOCALETARG	=	$localetarget
RPATH           =       $rpath_opt$shlib

!GROK!THIS!

if $test "$make_sets_make" != "$define" ; then  

	cat >>Makefile <<!GROK!THIS!
MAKE		=	$make
!GROK!THIS!

fi

if $test "$d_shared" = "$define" ; then

cat >>Makefile <<'!NO!SUBS!'
SHLIST          = $(BIN)/elm-shared
!NO!SUBS!

else

cat >>Makefile <<'!NO!SUBS!'
SHLIST          =
!NO!SUBS!

fi

cat >>Makefile <<'!NO!SUBS!'

#	Other general variables
BIN		=	../bin
CFLAGS		=	-I$(INCLDIR) $(CCFLAGS) $(OPTIMIZE)
INCLDIR		=	../hdrs
LINTFLAGS	=	-I$(INCLDIR)
SHELL		=	/bin/sh
REG             =       ../bin/elmregister

# 	Lists
ELM_SRC		=	addr_util.c	\
			alias.c		\
			aliaslib.c	\
			args.c		\
			a_edit.c	\
			a_screen.c	\
			a_sort.c	\
			a_quit.c	\
			attach_menu.c	\
			browser.c	\
			builtin++.c	\
			calendar.c	\
			curses.c	\
			date.c		\
			delete.c	\
			digest.c	\
			edit.c		\
			editmsg.c	\
			elm.c		\
			encode.c	\
			exitprog.c	\
			file.c		\
			file_util.c	\
			fileio.c	\
			find_alias.c	\
			forms.c		\
			hdrconfg.c	\
			help.c		\
			in_utils.c	\
			init.c		\
			leavembox.c	\
			lock.c		\
			limit.c		\
			mailmsg1.c	\
			mailmsg2.c	\
			menu.c		\
			menu2.c		\
			metapager.c	\
		 	mime.c          \
			mime_encode.c	\
			mkhdrs.c	\
			newmbox.c	\
			options.c	\
			out_utils.c	\
			pattern.c	\
			partial.c	\
			pgp.c		\
			quit.c		\
			read_rc.c	\
			remail.c	\
			reply.c		\
			save_opts.c	\
			savecopy.c	\
			screen.c	\
			showmsg.c	\
			showmsg_c.c	\
			signals.c	\
			sort.c		\
			string2.c	\
			strings.c	\
			syscall.c	\
			utils.c		

ELM_OBJ		=	addr_util.o	\
			alias.o		\
			aliaslib.o	\
			args.o		\
			attach_menu.o	\
			a_edit.o	\
			a_screen.o	\
			a_sort.o	\
			a_quit.o	\
			browser.o	\
			builtin++.o	\
			calendar.o	\
			curses.o	\
			date.o		\
			delete.o	\
			digest.o	\
			edit.o		\
			editmsg.o	\
			elm.o		\
			encode.o	\
			exitprog.o	\
			file.o		\
			file_util.o	\
			fileio.o	\
			find_alias.o	\
			forms.o		\
			hdrconfg.o	\
			help.o		\
			in_utils.o	\
			init.o		\
			leavembox.o	\
			lock.o		\
			limit.o		\
			mailmsg1.o	\
			mailmsg2.o	\
			menu.o		\
			menu2.o		\
			metapager.o	\
			mime.o		\
			mime_encode.o	\
			mkhdrs.o	\
			newmbox.o	\
			options.o	\
			out_utils.o	\
			pattern.o	\
			partial.o	\
			pgp.o		\
			quit.o		\
			read_rc.o	\
			remail.o	\
			reply.o		\
			save_opts.o	\
			savecopy.o	\
			screen.o	\
			showmsg.o	\
			showmsg_c.o	\
			signals.o	\
			sort.o		\
			string2.o	\
			strings.o	\
			syscall.o	\
			utils.o		

# Standard targets
all:		Makefile $(BIN)/elm $(SHLIST)
		cd messages; $(MAKE) $(MJ) $(MFLAGS) $@

install_s:	Makefile $(DEST) $(DEST)/elm  
		cd messages; $(MAKE) $(MJ) $(MFLAGS) $@

$(DEST):
		$(REG) mkdir $(DEST)

$(LIB):
		$(REG) mkdir $(LIB)

$(LIB)/elm.map.bin: 
		$(REG) mkdir $(LIB)/elm.map.bin

$(LIB)/elm.map.txt:
		$(REG) mkdir $(LIB)/elm.map.txt

messages/libmessages.a:
		cd messages; $(MAKE) $(MJ) $(MFLAGS) all

!NO!SUBS!

if $test "X$etc" != "X$lib" ; then

cat >>Makefile <<'!NO!SUBS!'
$(ETC):
	$(REG) mkdir $(ETC)

!NO!SUBS!

fi

cat >>Makefile <<'!NO!SUBS!'
uninstall_s:	
		$(REG) rm $(DEST)/elm 
		cd messages; $(MAKE) $(MJ) $(MFLAGS) $@


Makefile: Makefile.SH ../config.sh
	@echo "You must run 'sh Configure -S' or 'sh Configure'"
	exit 1

lint:		
		$(LINT) $(LINTFLAGS) $(ELM_SRC) > LINT.OUT

tags:
		$(TAGS) $(ELM_SRC)

clean: 
		$(RM) $(ELM_OBJ) $(BIN)/elm $(SHLIST)
		cd messages; $(MAKE) $(MJ) $(MFLAGS) $@


# Dependencies and rules
#	Dependencies of header files upon other header files they include
.PRECIOUS:		$(INCLDIR)/defs.h $(INCLDIR)/elm.h $(INCLDIR)/headers.h def_elm.h $(INCLDIR)/me.h

$(INCLDIR)/defs.h:	$(INCLDIR)/../config.h $(INCLDIR)/sysdefs.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

$(INCLDIR)/elm.h:	$(INCLDIR)/elm_curses.h $(INCLDIR)/defs.h  $(INCLDIR)/me.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

$(INCLDIR)/headers.h:	$(INCLDIR)/elm_curses.h $(INCLDIR)/defs.h $(INCLDIR)/mime.h $(INCLDIR)/me.h $(INCLDIR)/elmlib.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

$(INCLDIR)/me.h:	$(INCLDIR)/melib.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

def_elm.h:		$(INCLDIR)/headers.h $(INCLDIR)/me.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

#	Dependencies of C object files
addr_util.o:	def_elm.h $(INCLDIR)/s_elm.h
alias.o:	def_elm.h $(INCLDIR)/ndbz.h $(INCLDIR)/s_aliases.h $(INCLDIR)/s_elm.h
aliaslib.o:	def_elm.h $(INCLDIR)/s_elm.h
args.o:		def_elm.h $(INCLDIR)/patchlevel.h $(INCLDIR)/s_elm.h
a_edit.o:	def_elm.h
a_screen.o:	def_elm.h $(INCLDIR)/s_aliases.h
a_sort.o:	def_elm.h $(INCLDIR)/s_aliases.h
a_quit.o:	def_elm.h $(INCLDIR)/s_aliases.h
attach_menu.o:	def_elm.h $(INCLDIR)/s_elm.h $(INCLDIR)/s_me.h
browser.o:	def_elm.h $(INCLDIR)/s_elm.h
builtin++.o:	def_elm.h
calendar.o:	def_elm.h
curses.o:	def_elm.h $(INCLDIR)/s_elm.h
date.o:		def_elm.h
delete.o:	def_elm.h $(INCLDIR)/s_elm.h
digest.o:	def_elm.h $(INCLDIR)/s_elm.h
edit.o:		def_elm.h
editmsg.o:	def_elm.h $(INCLDIR)/s_elm.h
elm.o:		$(INCLDIR)/elm.h $(INCLDIR)/s_elm.h $(INCLDIR)/me.h $(INCLDIR)/patchlevel.h
encode.o:	def_elm.h $(INCLDIR)/s_elm.h
exitprog.o:	def_elm.h $(INCLDIR)/s_elm.h
file.o:		def_elm.h $(INCLDIR)/s_elm.h
file_util.o:	def_elm.h $(INCLDIR)/s_elm.h
fileio.o:	def_elm.h $(INCLDIR)/s_elm.h
find_alias.o:	def_elm.h
forms.o:	def_elm.h $(INCLDIR)/s_elm.h
hdrconfg.o:	def_elm.h $(INCLDIR)/s_elm.h 
help.o:		def_elm.h $(INCLDIR)/s_elm.h
in_utils.o:	def_elm.h $(INCLDIR)/s_elm.h
init.o:		def_elm.h $(INCLDIR)/patchlevel.h $(INCLDIR)/s_elm.h  $(INCLDIR)/s_elm.h 
leavembox.o:	def_elm.h $(INCLDIR)/s_elm.h $(INCLDIR)/me.h
limit.o:	def_elm.h $(INCLDIR)/s_elm.h $(INCLDIR)/s_aliases.h
lock.o:		def_elm.h $(INCLDIR)/s_elm.h
mailmsg1.o:	def_elm.h $(INCLDIR)/s_elm.h
mailmsg2.o:	def_elm.h $(INCLDIR)/s_elm.h $(INCLDIR)/menu2.h
menu2.o:	def_elm.h $(INCLDIR)/menu2.h
menu.o:		def_elm.h $(INCLDIR)/menu.h
metapager.o:	def_elm.h $(INCLDIR)/s_elm.h
mime.o:		def_elm.h $(INCLDIR)/s_elm.h
mime_encode.o:  def_elm.h
mkhdrs.o:	def_elm.h $(INCLDIR)/s_elm.h 
newmbox.o:	def_elm.h $(INCLDIR)/s_elm.h
options.o:	def_elm.h $(INCLDIR)/s_elm.h $(INCLDIR)/save_opts.h $(INCLDIR)/rc_imp.h
out_utils.o:	def_elm.h
pattern.o:	def_elm.h $(INCLDIR)/s_elm.h
partial.o:	def_elm.h $(INCLDIR)/s_elm.h
pgp.o:		def_elm.h
quit.o:		def_elm.h $(INCLDIR)/s_elm.h
read_rc.o:	def_elm.h $(INCLDIR)/s_elm.h $(INCLDIR)/save_opts.h $(INCLDIR)/rc_imp.h
remail.o:	def_elm.h $(INCLDIR)/s_elm.h
reply.o:	def_elm.h $(INCLDIR)/s_elm.h 
save_opts.o:	def_elm.h $(INCLDIR)/save_opts.h $(INCLDIR)/s_elmrc.h $(INCLDIR)/rc_imp.h
savecopy.o:	def_elm.h $(INCLDIR)/s_elm.h
screen.o:	def_elm.h $(INCLDIR)/s_elm.h
showmsg.o:	def_elm.h $(INCLDIR)/s_elm.h
showmsg_c.o:	def_elm.h $(INCLDIR)/s_elm.h
signals.o:	def_elm.h $(INCLDIR)/s_elm.h
sort.o:		def_elm.h $(INCLDIR)/s_elm.h
string2.o:	def_elm.h
strings.o:	def_elm.h $(INCLDIR)/s_elm.h
syscall.o:	def_elm.h $(INCLDIR)/s_elm.h $(INCLDIR)/s_me.h
utils.o:	def_elm.h $(INCLDIR)/s_elm.h

#	Dependencies and rules for compiling C programs
$(BIN)/elm:	$& $(ELM_OBJ) ../melib/libme.a ../lib/libutil.a messages/libmessages.a
		$(CC) $(LFLAGS) -o $@ $(ELM_OBJ) messages/libmessages.a ../melib/libme.a ../lib/libutil.a $(LIBS) $(LIB2)

#	Dependencies and rules for installing C programs


!NO!SUBS!

if $test "$d_shared" = "$define" ; then

cat >>Makefile <<'!NO!SUBS!'

$(BIN)/elm-shared: $& $(ELM_OBJ) ../melib/libme.a ../shlib/libelmme-base.so messages/libmessages.a 
		$(CC) $(LFLAGS) -o $@ $(RPATH) $(ELM_OBJ) messages/libmessages.a ../melib/libme.a ../shlib/libelmme-base.so $(LIBS) $(LIB2)


$(DEST)/elm:	$(BIN)/elm-shared
		$(REG) copy -g $(MAILGRP) -m $(MAILERMODE) $? $@

!NO!SUBS!

else

cat >>Makefile <<'!NO!SUBS!'
$(DEST)/elm:	$(BIN)/elm
		$(REG) copy -g $(MAILGRP) -m $(MAILERMODE) $? $@
!NO!SUBS!

fi
