static char rcsid[] = "@(#)$Id: digest.c,v 1.4 2003/08/04 14:58:58 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.4 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 *********************************************************************
 * This routine mimics some routines from src/file.c and src/elm.c.
 * That code was following copyright:
 *
 *  The Elm Mail System 
 *
 *			Copyright (c) 1988-1992 USENET Community Trust
 *			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

#include "def_elm.h"
#include "s_elm.h"

DEBUG_VAR(Debug,__FILE__,"ELM");

static void digest_menu P_((void));
static void digest_menu()
{
    /** write main system menu... **/

    if (user_level == 0) {	/* a rank beginner.  Give less options  */
	  print_format_center(elm_LINES-7, 
			      CATGETS(elm_msg_cat, ElmSet, 
				      ElmLevel0MenuLine1,
				      "You can use any of the following commands by pressing the first character;"));
         print_format_center(elm_LINES-6, 
			     CATGETS(elm_msg_cat, ElmSet, 
				     ElmLevel0DgtLine2,
				     "m)ail a message,  r)eply or f)orward mail,  return to i)ndex"));
	 print_format_center(elm_LINES-5, 
			     CATGETS(elm_msg_cat, ElmSet, 
				     ElmLevel0DgtLine3,
				     "To read a message, press <return>.  j = move down, k = move up"));
    } else {
	print_format_center(elm_LINES-7, 
			    CATGETS(elm_msg_cat, ElmSet, 
				    ElmLevel1MenuLine1,
				    "|=pipe, !=shell, ?=help, <n>=set current to n, /=search pattern"));
        print_format_center(elm_LINES-6, 
			    CATGETS(elm_msg_cat, ElmSet, 
				    ElmLevel1DgtLine2,
				    "a)lias, C)opy, f)orward, g)roup reply, m)ail,"));
	print_format_center(elm_LINES-5, 
			    CATGETS(elm_msg_cat, ElmSet, 
				    ElmLevel1DgtLine3,
				    "n)ext, o)ptions, P)rint text, r)eply, s)ave, t)ag, or i)index"));
    }
}

static int showmsg_digest_cmd P_((     struct MailboxView *mailbox,
				       int cmd, int *screen_mangled));
static int showmsg_digest_cmd(mailbox,cmd,screen_mangled)
     struct MailboxView *mailbox;
     int cmd; 
     int *screen_mangled;
{
    return cmd;
}


static void digest_loop P_((struct MailboxView *mailbox));
static void digest_loop(mailbox)
     struct MailboxView *mailbox;
{
    int leave = 0;
    int redraw = 0, nufoot = 0;
    int auto_assemble = 1;

    showscreen(mailbox,
	       digest_menu);


    while (!leave) {
	int ch;

#ifdef SIGWINCH
	if (resize_screen) {
	    int	newLINES, newCOLUMNS;
	    
	    ScreenSize(&newLINES, &newCOLUMNS);
	    resize_screen = 0;
	    if (newLINES != elm_LINES || newCOLUMNS != elm_COLUMNS) {
		elm_LINES = newLINES, elm_COLUMNS = newCOLUMNS;
#undef max
#define max(a,b)	       ((a) < (b) ? (b) : (a))
		if (mini_menu)
		    headers_per_page = max (elm_LINES - 13, 1);
		else
		    headers_per_page = max (elm_LINES -	 8, 1);	  /* 5 more headers! */
#undef max
		redraw++;
	    }
	}
	else redraw = 0;
#else
	redraw = 0;
#endif
	nufoot = 0;
	nucurr = 0;


	if (update_view(mailbox)) {
	    resort_mailbox(mailbox,1);

	    redraw++;
	}

	if (redraw) {
	    redraw = 0;
	    showscreen(mailbox,
		       digest_menu);
	    show_last_error();
	}
	

	prompt(Prompt);

	CleartoEOLN();

	if (auto_assemble && 2 == fragment_handling &&
	    have_partial(mailbox)) {
	    ch = 'A';
	    auto_assemble = 0;

	    DPRINT(Debug,4,(&Debug,"Automatic assemble ... \n"));
	} else
	    ch = GetPrompt();
	
	if (redraw_screen) {
	    redraw_screen = 0;
	    redraw++;
	}

#ifdef SIGWINCH
	if (resize_screen) {
	    int	newLINES, newCOLUMNS;
	    
	    ScreenSize(&newLINES, &newCOLUMNS);
	    resize_screen = 0;
	    if (newLINES != elm_LINES || newCOLUMNS != elm_COLUMNS) {
		elm_LINES = newLINES, elm_COLUMNS = newCOLUMNS;
#define max(a,b)	       ((a) < (b) ? (b) : (a))
		if (mini_menu)
		    headers_per_page = max (elm_LINES - 13, 1);
		else
		    headers_per_page = max (elm_LINES - 8, 1);	  /* 5 more headers! */
#undef max
		redraw++;
	    }
	}
#endif
	CleartoEOS();

	if (isascii(ch) && isprint(ch)) {
	    DPRINT(Debug,4,(&Debug, 
			    "\nCommand: %c [%d]\n\n", ch, ch));
	} else {
	    DPRINT(Debug,4,(&Debug, 
			    "\nCommand: %d\n\n", ch));
	}

	set_error("");	/* clear error buffer */
	
	MoveCursor(elm_LINES-3,strlen(Prompt));
	
	ch = mailbox_command(mailbox,ch, &redraw, &nufoot,
			     showmsg_digest_cmd);

	switch (ch) {
	case 0:  /* OK */
	    break;

	case 'A': {
	    int current = get_current(mailbox);


	    Write_to_screen(CATGETS(elm_msg_cat, 
					     ElmSet, ElmAssemble,
					     "Assemble message fragments"));
	    FlushBuffer();
	    sleep_message();

	    ViewPartial(mailbox);
	    
	    (void)get_page(current, mailbox);
	    redraw++;

	}
	    break;

	case ctrl('Q') :
	case 'q':
	case 'Q':
	case 'i':
	case 'x':
	case 'X':
	    Write_to_screen(CATGETS(elm_msg_cat, ElmSet,
				    ElmReturnIndex,
				    "Return to index"));  
	    FlushBuffer();

	    leave = 1;

	    break;
	case EOF:
	    
	    return;

	default:
	    lib_error(CATGETS(elm_msg_cat, ElmSet,
			      ElmUnknownCommand2,			
			      "Unknown command."));

	}
	
	if (redraw)
	    showscreen(mailbox,
		       digest_menu);
	
	check_range(mailbox);
	
	
	if (nucurr == NEW_PAGE) {
	    DPRINT(Debug,5,(&Debug,  " nucurr == NEW_PAGE\n"));
	    show_headers(mailbox);
	} else if (nucurr == SAME_PAGE) {
	    DPRINT(Debug,5,(&Debug,  " nucurr == SAME_PAGE\n"));
	    show_current(mailbox);
	} else if (nufoot) {
	    if (mini_menu) {
		MoveCursor(elm_LINES-7, 0);  
		CleartoEOS();
		digest_menu();
	    }
	    else {
		MoveCursor(elm_LINES-4, 0);
		CleartoEOS();
	    }
	    show_last_error();	/* for those operations that have to
				 * clear the footer except for a message.
				 */
	}

    } /* the BIG while loop! */
}

void ViewDigest(parent_mailbox)
     struct MailboxView *parent_mailbox;
{
    int oldstat = 0, tagged = 0;
    int mc,i;
    struct MailboxView *new_mailbox = NULL;
    int current = get_current(parent_mailbox);
    struct header_rec * chdr = give_header(parent_mailbox,current-1);

    if (chdr) 
	oldstat = chdr->status;	/* remember */

    mc = get_message_count(parent_mailbox);
    for (i=0; i < mc; i++) {
	struct header_rec * hdr = give_header(parent_mailbox,i);
	if (hdr && ison(hdr->status, TAGGED)) {
	    tagged++;
	}
    }

    if (tagged == 0) {

	tagged = 1;
	if (chdr)
	    setit(chdr->status, TAGGED);
    }

    mc = get_message_count(parent_mailbox);
    for (i=0; i < mc; i++) {	/* get each tagged msg */
	struct header_rec * hdr = give_header(parent_mailbox,i);
	if (hdr && ison(hdr->status, TAGGED)) {
	    FILE *F;

	    clearit(hdr->status, TAGGED);

	    if (give_message_data(parent_mailbox,i,
				  &hdr,&F,NULL,
				  mime_parse_routine)) {
		if (new_mailbox)
		    add_digest(new_mailbox,
			       & hdr->mime_rec,
			       hdr->received_time,
			       hdr->env_from,
			       F,
			       hdr->header_charset);
		else
		    new_mailbox = 
			digest_to_mailbox_view(& hdr->mime_rec,
					       hdr->received_time,
					       hdr->env_from,
					       F,
					       hdr->header_charset);
	    }

	}
    }

    if (chdr)
	chdr->status = oldstat;	/* BACK! */


    if (new_mailbox) {
	if (get_message_count(new_mailbox) > 0) {
	    set_current(new_mailbox,1);   /* Set current to first message */

	    update_view(new_mailbox);
	    resort_mailbox(new_mailbox,1);
	}

	digest_loop(new_mailbox);

	free_mailbox(& new_mailbox);
    }

    return;
}

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */
