static char rcsid[] = "@(#)$Id: exitprog.c,v 1.8 2003/07/29 18:46:19 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.8 $   $State: Exp $
 *
 *  Modified by: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 ******************************************************************************
 *  The Elm Mail System 
 *
 *			Copyright (c) 1988-1992 USENET Community Trust
 *			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

#include "def_elm.h"
#include "s_elm.h"

DEBUG_VAR(Debug,__FILE__,"ELM");

int exit_prog(mailbox)
     struct MailboxView **mailbox;
{
    /** Exit, abandoning all changes to the mailbox (if there were
	any, and if the user say's it's ok)
    **/

    char msg[SLEN], answer;
    int i, changes = 0;
    int mc;
    
    DPRINT(Debug,1,
	   (&Debug, "\n\n-- exiting --\n\n"));
    
    /* Determine if any messages are scheduled for deletion, or if
     * any message has changed status
     */
    mc = get_message_count(*mailbox);
    for (changes = 0, i = 0; i < mc; i++) {
	struct header_rec * hdr = give_header(*mailbox,i);
	
	if (ison(hdr->status, DELETED) || hdr->status_chgd)
	    changes++;
    }
	

    if (changes) {
	  /* YES or NO on softkeys */
	  /*
	  if (hp_softkeys) {
	    define_softkeys(YESNO);
	    softkeys_on();
	  }
	  */
	  if (changes == 1)
	    elm_sfprintf(msg, sizeof msg,
			 CATGETS(elm_msg_cat, ElmSet, ElmAbandonChange,
				 "Abandon change to mailbox? (%c/%c) "), 
			 *def_ans_yes, *def_ans_no);
	  else
	    elm_sfprintf(msg, sizeof msg,
			 CATGETS(elm_msg_cat, ElmSet, ElmAbandonChangePlural,
				 "Abandon changes to mailbox? (%c/%c) "), 
			 *def_ans_yes, *def_ans_no);
	  answer = want_to(msg, *def_ans_no, elm_LINES-3, 0);

	  if(answer != *def_ans_yes) return -1;
	}

	FlushBuffer();
	leave(0, mailbox);   
	return 0;
}

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */
