/* $Id: def_messages.h,v 1.4 2003/08/04 14:58:58 hurtta Exp $ */

#include "headers.h"
#include "me.h"

#if ANSI_C
struct MailboxView;
#endif

typedef void mt_init_mailbox P_((struct MailboxView *mbx));
typedef void mt_free_mailbox P_((struct MailboxView *mbx));
typedef void mt_add_mailbox_storage P_((struct MailboxView *mailbox,
					struct current_storage *storage));

/* Return 1 if redraw required */
typedef int mt_update_view_mailbox P_((struct MailboxView *mailbox));

typedef struct folder_info * mt_get_main_mailbox_folder P_((struct MailboxView *mailbox));

/* Can be called from signal handler */
typedef struct current_storage * mt_get_mailbox_storage P_((struct MailboxView *mailbox,
							    int i));

/* Can be called from signal handler */
typedef int mt_get_mailbox_storage_count P_((struct MailboxView *mailbox));

typedef struct header_rec * mt_give_header_mailbox P_((struct MailboxView *mailbox,
						       int index, 
						       struct folder_view *v));

typedef void mt_sort_mailbox_view P_((struct MailboxView *mailbox,
				      hdr_compare_func   *func));

/* Return 1 if succeed, 0 is fails --
   seeks to {header}->offset   (if ret_F set)
*/
typedef int mt_give_message_data_mailbox P_((struct MailboxView *mailbox,
					     int index,
					     struct header_rec **ret_header,
					     FILE              **ret_F,
					     struct counter_data *counter,
					     parse_mime_callback *parse_mime,
					     struct folder_view *v));


/* This is not good ... */
typedef int mt_give_message_folder_mailbox P_((struct MailboxView *mailbox,
					       int index,
					       struct header_rec **ret_header,
					       struct folder_info **ret_folder,
					       struct counter_data *counter,
					       parse_mime_callback *parse_mime,
					       struct folder_view *v));
typedef void mt_write_mailbox_info P_((FILE *fp, struct MailboxView *mailbox,
				       int s, int cur_idx));
typedef struct string * mt_mailbox_title P_((struct MailboxView *mailbox));
typedef void mt_make_mailbox_view P_((struct MailboxView *mailbox));

typedef void mt_add_mailbox_digest P_((struct MailboxView *mailbox,
				       mime_t *list,
				       time_t received_time,
				       char *env_from,
				       FILE *F,
				       charset_t defcharset));

extern struct mailbox_type {
    unsigned short            magic;      /* MAILBOXTYPE_magic */

    mt_init_mailbox                * mt_init_it;
    mt_free_mailbox                * mt_free_it;
    mt_add_mailbox_storage         * mt_add_it_storage;
    mt_update_view_mailbox         * mt_update_view_it;
    mt_get_main_mailbox_folder     * mt_get_main_it_folder;
    mt_get_mailbox_storage         * mt_get_it_storage;
    mt_get_mailbox_storage_count   * mt_get_it_storage_count;
    mt_give_header_mailbox         * mt_give_header_it;
    mt_sort_mailbox_view           * mt_sort_it_view;
    mt_give_message_data_mailbox   * mt_give_message_data_it;
    mt_give_message_folder_mailbox * mt_give_message_folder_it;
    mt_write_mailbox_info          * mt_write_it_info;
    mt_mailbox_title               * mt_it_title;
    mt_make_mailbox_view           * mt_make_it_view;
    mt_add_mailbox_digest          * mt_add_it_digest;
} mt_storage, mt_digest, mt_partial;

#define MAILBOXTYPE_magic       0xFC02

struct MailboxView {
    unsigned short            magic;      /* MAILBOXVIEW_magic */
    struct mailbox_type     * mailbox_type;

    union {
	struct mv_storage {
	    struct current_storage  ** the_mailbox;
	    int                       mailbox_count;
	    
	}                           * storage;

	struct mv_digest {
	    struct current_digest   ** the_digest;
	    int                     digest_count;
	}                           * digest;
	
	struct mv_partial {
	    struct MailboxView       * parent_mailbox;
	    	   
	    struct composite_vector  * composite;
	    int                      composite_len;

	    FILE                    *F;
	    char                    *fname;

	}                           * partial;

	void                        * dummy;                      
    } u;

    struct folder_view      * view;
    int                       view_len;

    /* Values set by caller */
    int        current;
    int        selected;
    struct string           * mailbox_title;
};


typedef struct header_rec * sdt_give_header_s P_((struct sort_data *s,
						  struct folder_view *v));

#define SORTDATATYPE_magic      0xFC03

struct sort_data_type {
    unsigned short            magic;      /* SORTDATATYPE_magic */

    sdt_give_header_s       * sdt_give_header;
};

/* Needed extra structure for soring so passing of
   global data is not needed
*/
struct sort_data {
    struct sort_data_type  * sort_data_type;
    struct folder_view      w;
    union {
	struct current_storage *mbx;
	struct current_digest  *dgt;
	struct partial_sort    *part;
	void                   *dummy;
    } u;
};

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */
