static char rcsid[] = "@(#)$Id: partial.c,v 1.3 2003/08/11 06:53:24 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.3 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 *********************************************************************
 * This routine mimics some routines from src/file.c and src/elm.c.
 * That code was following copyright:
 *
 *  The Elm Mail System 
 *
 *			Copyright (c) 1988-1992 USENET Community Trust
 *			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

#include "def_elm.h"
#include "s_elm.h"

DEBUG_VAR(Debug,__FILE__,"ELM");

static void partial_menu P_((void));
static void partial_menu()
{
    /** write main system menu... **/

    if (user_level == 0) {	/* a rank beginner.  Give less options  */
	  print_format_center(elm_LINES-7, 
			      CATGETS(elm_msg_cat, ElmSet, 
				      ElmLevel0MenuLine1,
				      "You can use any of the following commands by pressing the first character;"));
         print_format_center(elm_LINES-6, 
			     CATGETS(elm_msg_cat, ElmSet, 
				     ElmLevel0PartLine2,
				     "d)elete or u)ndelete mail,  m)ail a message,  r)eply or f)orward mail,  return to i)ndex"));
	 print_format_center(elm_LINES-5, 
			     CATGETS(elm_msg_cat, ElmSet, 
				     ElmLevel0PartLine3,
				     "To read a message, press <return>.  j = move down, k = move up"));
    } else {
	print_format_center(elm_LINES-7, 
			    CATGETS(elm_msg_cat, ElmSet, 
				    ElmLevel1MenuLine1,
				    "|=pipe, !=shell, ?=help, <n>=set current to n, /=search pattern"));
        print_format_center(elm_LINES-6, 
			    CATGETS(elm_msg_cat, ElmSet, 
				    ElmLevel1PartLine2,
				    "a)lias, C)opy, d)elete, f)orward, g)roup reply, m)ail,"));
	print_format_center(elm_LINES-5, 
			    CATGETS(elm_msg_cat, ElmSet, 
				    ElmLevel1PartLine3,
				    "n)ext, o)ptions, P)rint text, r)eply, s)ave, t)ag, or i)index"));
    }
}

static int showmsg_partial_cmd P_((     struct MailboxView *mailbox,
				       int cmd, int *screen_mangled));
static int showmsg_partial_cmd(mailbox,cmd,screen_mangled)
     struct MailboxView *mailbox;
     int cmd; 
     int *screen_mangled;
{
    switch (cmd) {
    case '|' : {
	int current = get_current(mailbox);
	
	put_cmd_name(catgets(elm_msg_cat, ElmSet, ElmPipe, "Pipe"), 
		     TRUE);
	
	if (give_message_data(mailbox,current-1,
			      NULL,NULL,NULL,
			      NO_mime_parse))
	    (void) do_pipe(mailbox);     /* do pipe - ignore return val */
	else {
	    DPRINT(Debug,3,(&Debug, 
			    "give_message_data [%d] fails",current-1));
	}
	ClearScreen();
	build_bottom();
    }
	break;
    }

    return cmd;
}


static void partial_loop P_((struct MailboxView *mailbox));
static void partial_loop(mailbox)
     struct MailboxView *mailbox;
{
    int leave = 0;
    int redraw = 0, nufoot = 0;

    showscreen(mailbox,
	       partial_menu);


    while (!leave) {
	int ch;

#ifdef SIGWINCH
	if (resize_screen) {
	    int	newLINES, newCOLUMNS;
	    
	    ScreenSize(&newLINES, &newCOLUMNS);
	    resize_screen = 0;
	    if (newLINES != elm_LINES || newCOLUMNS != elm_COLUMNS) {
		elm_LINES = newLINES, elm_COLUMNS = newCOLUMNS;
#undef max
#define max(a,b)	       ((a) < (b) ? (b) : (a))
		if (mini_menu)
		    headers_per_page = max (elm_LINES - 13, 1);
		else
		    headers_per_page = max (elm_LINES -	 8, 1);	  /* 5 more headers! */
#undef max
		redraw++;
	    }
	}
	else redraw = 0;
#else
	redraw = 0;
#endif
	nufoot = 0;
	nucurr = 0;

	new_mail_check(mailbox,&redraw);

	if (update_view(mailbox)) {
	    resort_mailbox(mailbox,1);

	    redraw++;
	}

	if (redraw) {
	    redraw = 0;
	    showscreen(mailbox,
		       partial_menu);
	    show_last_error();
	}
	

	prompt(Prompt);

	CleartoEOLN();
	ch = GetPrompt();
	
	if (redraw_screen) {
	    redraw_screen = 0;
	    redraw++;
	}

#ifdef SIGWINCH
	if (resize_screen) {
	    int	newLINES, newCOLUMNS;
	    
	    ScreenSize(&newLINES, &newCOLUMNS);
	    resize_screen = 0;
	    if (newLINES != elm_LINES || newCOLUMNS != elm_COLUMNS) {
		elm_LINES = newLINES, elm_COLUMNS = newCOLUMNS;
#define max(a,b)	       ((a) < (b) ? (b) : (a))
		if (mini_menu)
		    headers_per_page = max (elm_LINES - 13, 1);
		else
		    headers_per_page = max (elm_LINES - 8, 1);	  /* 5 more headers! */
#undef max
		redraw++;
	    }
	}
#endif
	CleartoEOS();

	if (isascii(ch) && isprint(ch)) {
	    DPRINT(Debug,4,(&Debug, 
			    "\nCommand: %c [%d]\n\n", ch, ch));
	} else {
	    DPRINT(Debug,4,(&Debug, 
			    "\nCommand: %d\n\n", ch));
	}

	set_error("");	/* clear error buffer */
	
	MoveCursor(elm_LINES-3,strlen(Prompt));
	
	ch = mailbox_command(mailbox,ch, &redraw, &nufoot,
			     showmsg_partial_cmd);

	switch (ch) {
	case 0:  /* OK */
	    break;

	case '|'    :   {
	    int current = get_current(mailbox);
	    
	    Writechar('|');
	    
	    if (current < 1) {
		lib_error(CATGETS(elm_msg_cat, ElmSet, 
				  ElmNoMailToPipe,
				  "No mail to pipe!"));
		
	    } else if (give_message_data(mailbox,current-1,
					 NULL,NULL,NULL,NO_mime_parse)) {
		
		/* softkeys_off(); */
		
		redraw += do_pipe(mailbox);		
		/* softkeys_on(); */
	    } else {
		DPRINT(Debug,3,(&Debug, 
				"give_message_data [%d] fails",current-1));
	    }
	}
	    break;


	case ctrl('Q') :
	case 'q':
	case 'Q':
	case 'i':
	case 'x':
	case 'X':
	    Write_to_screen(CATGETS(elm_msg_cat, ElmSet,
				    ElmReturnIndex,
				    "Return to index"));  
	    FlushBuffer();

	    leave = 1;

	    break;
	case EOF:
	    
	    return;

	default:
	    lib_error(CATGETS(elm_msg_cat, ElmSet,
			      ElmUnknownCommand2,			
			      "Unknown command."));

	}
	
	if (redraw)
	    showscreen(mailbox,
		       partial_menu);
	
	check_range(mailbox);
	
	
	if (nucurr == NEW_PAGE) {
	    DPRINT(Debug,5,(&Debug,  " nucurr == NEW_PAGE\n"));
	    show_headers(mailbox);
	} else if (nucurr == SAME_PAGE) {
	    DPRINT(Debug,5,(&Debug,  " nucurr == SAME_PAGE\n"));
	    show_current(mailbox);
	} else if (nufoot) {
	    if (mini_menu) {
		MoveCursor(elm_LINES-7, 0);  
		CleartoEOS();
		partial_menu();
	    }
	    else {
		MoveCursor(elm_LINES-4, 0);
		CleartoEOS();
	    }
	    show_last_error();	/* for those operations that have to
				 * clear the footer except for a message.
				 */
	}

    } /* the BIG while loop! */
}

void ViewPartial(parent_mailbox)
     struct MailboxView *parent_mailbox;
{
    struct MailboxView *new_mailbox = NULL;

    new_mailbox = partial_to_mailbox_view(parent_mailbox);

    if (new_mailbox) {
	if (get_message_count(new_mailbox) > 0) {
	    set_current(new_mailbox,1);   /* Set current to first message */

	    update_view(new_mailbox);
	    resort_mailbox(new_mailbox,1);
	}

	partial_loop(new_mailbox);

	free_mailbox(& new_mailbox);
    }

    return;
}

int have_partial(parent_mailbox)
     struct MailboxView *parent_mailbox;
{
    int mc = get_message_count(parent_mailbox);
    int i;
    
    for (i = 0; i < mc; i++) {
	struct header_rec * hdr = give_header(parent_mailbox,i);
	int z;

	if (hdr && (hdr->partial_len ||
		    (hdr->status & MIME_MESSAGE) &&
		    (z = get_type_flags(hdr->mime_rec.TYPE)) &&
		    ( z & MIME_PARTIAL))) {
	    DPRINT(Debug,4,(&Debug, 
			    "have_partial=1   (message %d)\n",
			    i+1));
	    return 1;
	}

    }

    DPRINT(Debug,9,(&Debug, 
		    "have_partial=0   (message %d)\n"));

    return 0;
}
/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */
